;*****************************************
;SAMdisk_GUI.au3 by Volker Pohlers
;Erstellt mit ISN AutoIt Studio v. 0.92 BETA
;*****************************************
;letzte nderung: 11.7.2013

;Options
Opt("GUIOnEventMode", 1)

#include <GUIConstantsEx.au3>
#include <GUIComboBox.au3>
#include <WindowsConstants.au3>
#include <Array.au3>
#include <WinAPI.au3>

#include <Forms\main.isf>

Global Const $PROCESS_QUERY_INFORMATION = 0x0400

;Programm Code
GUISetState(@SW_SHOW, $main)
GUISetOnEvent($GUI_EVENT_CLOSE, "_Exit", $main)
GUICtrlSetData($state, "") ;

GUICtrlSetData($title, "SAMdisk GUI 0.3 11.6.2016") ;


;Drive List
$driveList = DriveGetDrive("REMOVABLE")
If @error Then
	Local $driveList[1]
EndIf
GuiCtrlSetData($drive, "|" & _ArrayToString($driveList, "|", 1))
_GUICtrlComboBox_SetCurSel($drive, 0)

While 1
	Sleep(20)
WEnd

;create image from disk

Func _ReadDisk()
	local $file = FileSaveDialog("select image name", "", "edsk images (*.dsk)|all files (*.*)", 16)
	If @error Then
		Return
	EndIf
	if StringInStr($file, ".") = 0 Then
		$file = $file & ".dsk"
	EndIf

	local $floppydrv = GUICtrlRead($drive)
	if $floppydrv = "" Then
		MsgBox(16, "Error", "no floppy drive selected", 0)
		Return
	EndIf

	local $options = " -c80"
	;$text = _getDOSOutput("dir", @scriptdir)
	$text = _getDOSOutput("SAMdisk.exe " & $floppydrv & ' "' & $file & '"' & $options, @scriptdir)
	if @error then
		MsgBox(16, "Error", $text, 0)
		GUICtrlSetData($state, $text)
	else
		GUICtrlSetData($state, "image " & $file & " saved")
	EndIf
EndFunc

;write disk from image

Func _WriteDisk()
	local $file = FileOpenDialog("select image", "", "edsk images (*.dsk)|all files (*.*)", 1)
	If @error Then
		Return
	EndIf

	local $floppydrv = GUICtrlRead($drive)
	if $floppydrv = "" Then
		MsgBox(16, "Error", "no floppy drive selected", 0)
		Return
	EndIf

	local $options = ""
	if GUICtrlRead($drive) = $GUI_UNCHECKED then
		$options = " --no-format"
	EndIf

	$text = _getDOSOutput('SAMdisk.exe "' & $file & '" ' & $floppydrv & $options, @scriptdir)
	if @error then
		MsgBox(16, "Error", $text, 0)
		GUICtrlSetData($state, $text)
	else
		GUICtrlSetData($state, "image " & $file & " written")
	EndIf
EndFunc

;convert image

Func _ConvertImage()
	local $file = FileOpenDialog("select image", "", "teledisk (*.td0)|imagedisk (*.imd)|raw images (*.raw)|all files (*.*)", 1)
	If @error Then
		Return
	EndIf

	local $newfile = $file ;

	; replace file ext to .dsk
	if StringInStr($newfile, ".") = 0 Then
		$newfile = $newfile & ".dsk"
	Else
		$newfile = StringRegExpReplace($newfile, "(\..+?)$", ".dsk")
	EndIf

	$text = _getDOSOutput('SAMdisk.exe "' & $file & '" "' & $newfile & '"', @scriptdir)
	if @error then
		MsgBox(16, "Error", $text, 0)
		GUICtrlSetData($state, $text)
	else
		GUICtrlSetData($state, "image " & $newfile & " written")
	EndIf
EndFunc

;exit program

Func _Exit()
	Exit
EndFunc ;==>_Exit

;*****************************************
; Ausfhren eines DOS-Programms
; Abfangen der Ausgabe Stdout+StdErr
;*****************************************

Func _getDOSOutput($command, $dir = '')
	Local $text = '', $Pid

   GUISetCursor(15,  $GUI_CURSOR_OVERRIDE) ; WAIT
   GUICtrlSetData($state, 'run ' & $command & ' ...');

   ; MsgBox(0,"cmd", '"' & @ComSpec & '" /c ' & $command & " / in " &  $dir)
	$Pid = Run('"' & @ComSpec & '" /c ' & $command, $dir, @SW_HIDE, 8)
	$hPID = _WinAPI_OpenProcess($PROCESS_QUERY_INFORMATION, 0, $Pid)

	$text = ""

	While ProcessExists($Pid)
		Sleep(10)
		;While Not @error
		;   $text &= StdoutRead($Pid)
		;WEnd
		;GUICtrlSetData($state,$text);
	WEnd

   GUISetCursor(2) ;  ARROW

	local $error = _ProcessGetExitCode($hPID) ;Get process exit code from handle
	_WinAPI_CloseHandle($hPID)

	While 1
		$text &= StdoutRead($Pid, False, False)
		If @error Then ExitLoop
	WEnd

   GUICtrlSetData($state,$text);
   ;MsgBox(0,"cmd",$text);

	SetError($error) ;@error setzen
	Return $text
EndFunc ;==>_getDOSOutput

Func _ProcessGetExitCode($hProc) ;Get process exit code from handle
	Local $t_ExitCode = DllStructCreate('int')
	Local $avRET = DllCall('kernel32.dll', 'int', 'GetExitCodeProcess', 'ptr', $hProc, 'ptr', DllStructGetPtr($t_ExitCode))
	If @error Then
		Return SetError(1, 0, 0)
	Else
		Return DllStructGetData($t_ExitCode, 1)
	EndIf
EndFunc

